<template>
    <div class="box__pcDop--white">
        <p class="text-one"><span>*</span>{{ $t('payment_systems.form.required_help') }} </p>
        <form action="" ref="form" :id="formId" @submit.prevent="submit">
            <div class="box__pcDop--top">
                <div class="box__pcDop--left">
                    <div class="box__pcDopLeft--element">
                        <label for="form_provider"><span>*</span> {{ $t('payment_systems.form.provider') }}</label>
                        <div class="box__pcDopLeftElement--right">
							<form-select id="form_provider" v-model="form.provider" name="provider" :options="providers_options" class="selectClass" :wrapper-style="{}" :span-style="{color: '#000', padding: '14px 0 14px 15px', width: 'calc(100% - 30px)'}" :custom-options-style="{'z-index': 1, width: 'calc(100% - 30px - 1em)'}" :trigger-style="{right: '25px'}"/>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <div class="box__pcDopLeft--element">
                        <label for="form_name"><span>*</span>{{ $t('payment_systems.form.name') }}</label>
                        <div class="box__pcDopLeftElement--right">
                            <div class="selectClass">
                                <input id="form_name" type="text" v-model="form.name" placeholder="">
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <div class="box__pcDopLeft--element">
                        <label for="form_wallet"><span>*</span>{{ $t('payment_systems.form.wallet') }}</label>
                        <div class="box__pcDopLeftElement--right">
                            <div class="selectClass">
                                <input id="form_wallet" type="text" v-model="form.wallet" placeholder="">
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <div class="box__pcDopLeft--element">
                        <label for="form_code"><span>*</span>{{ $t('payment_systems.form.code') }}</label>
                        <div class="box__pcDopLeftElement--right">
                            <div class="selectClass">
                                <input id="form_code" type="text" v-model="form.code" placeholder="">
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <div class="box__pcDopLeft--element">

                        <label for="form_refill_commission"><span>*</span>{{ $t('payment_systems.form.refill_commission') }}</label>
                        <div class="box__pcDopLeftElement--right">
                            <div class="selectClass">
                                <input id="form_refill_commission" type="number" v-model.number="form.refill_commission" placeholder="">
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <div class="box__pcDopLeft--element">
                        <label for="form_withdraw_commission"><span>*</span>{{ $t('payment_systems.form.withdraw_commission') }}</label>
                        <div class="box__pcDopLeftElement--right">
                            <div class="selectClass">
                                <input id="form_withdraw_commission" type="number" v-model.number="form.withdraw_commission" placeholder="">
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                </div>
                <div class="box__pcDop--right">
                    <div class="box__pcDopRight--element" style="flex-wrap: nowrap;">
                        <label for="form_currency_id" class="box__pcDopRightElement--left"><span>*</span> {{ $t('payment_systems.form.currency') }}</label>
                        <div class="box__pcDopRightElement--right">
							<form-select id="form_currency_id" v-model="form.currency_id" name="provider" :options="currencies_options" class="selectClass" :wrapper-style="{}" :span-style="{color: '#000', padding: '14px 0 14px 15px', width: 'calc(100% - 30px)'}" :custom-options-style="{'z-index': 1, width: 'calc(100% - 30px - 1em)'}" :trigger-style="{right: '25px'}"/>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <div class="box__pcDopRight--element">
                        <label for="form_min_refill_amount"> <span>*</span> {{ $t('payment_systems.form.refill_amount') }}</label>
                        <div class="box__element--right">
                            <div class="box-min">
                                <label class="min" for="form_min_refill_amount">{{ $t('ui.min') }}</label>
                                <input id="form_min_refill_amount" type="number" v-model.number="form.min_refill_amount" placeholder="">
                            </div>
                            <div class="box-min">
                                <label for="form_max_refill_amount">{{ $t('ui.max') }}</label>
                                <input id="form_max_refill_amount" type="number" v-model.number="form.max_refill_amount" placeholder="">
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <div class="box__pcDopRight--element">
                        <label for="form_min_withdraw_amount"> <span>*</span> {{ $t('payment_systems.form.withdraw_amount') }}</label>
                        <div class="box__element--right">
                            <div class="box-min">
                                <label for="form_min_withdraw_amount">{{ $t('ui.min') }}</label>
                                <input id="form_min_withdraw_amount" type="number" v-model.number="form.min_withdraw_amount" placeholder="">
                            </div>
                            <div class="box-min">
                                <label for="form_max_withdraw_amount">{{ $t('ui.max') }}</label>
                                <input id="form_max_withdraw_amount" type="number" v-model.number="form.max_withdraw_amount" placeholder="">
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>
                        </div>
                    </div>
                    <withdraw-types-radio v-model="form.withdraw_type" :types="provider_withdraw_types"/>
                    <div class="box__pcDopRight--element">
                        <label for=""> <span>*</span> {{ $t('payment_systems.form.usage_settings') }}</label>
                        <div class="box__element--right">
                            <ui-checkbox v-model="form.can_refill" width="20%">{{ $t('payment_systems.form.usage_types.refill') }}</ui-checkbox>
                            <ui-checkbox v-model="form.can_withdraw" width="20%">{{ $t('payment_systems.form.usage_types.withdraw') }}</ui-checkbox>
                            <ui-checkbox v-model="form.need_wallet" width="20%">{{ $t('payment_systems.form.usage_types.wallet') }}</ui-checkbox>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>

                        </div>
                    </div>
                    <div class="box__pcDopRight--element">
                        <label for="form_enabled"> <span>*</span> {{ $t('payment_systems.form.status') }}</label>
                        <div class="box__element--right">
                            <div class="box-min">
                                <div class="right__left">
                                    <p class="text-off">{{ $t('ui.off') }}</p>
                                    <div class="box-c">
                                        <input type="checkbox" class="checkbox" id="form_enabled" name="form_enabled" :true-value="1" :false-value="0" :checked="form.enabled" @change="toggleEnabled"/>
                                        <label for="form_enabled"/>
                                    </div>
                                    <p class="text-off">{{ $t('ui.on') }}</p>
                                </div>
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit." :ml="0"/>

                        </div>
                    </div>
                </div>
            </div>
            <p class="text-one">{{ $t('payment_systems.form.access_settings') }}</p>
            <div class="box__pcDop--bottom">
                <div class="box__bottom--element" v-for="(label, field) in provider_fields">
                    <label :for="'form_credentials_' + field">{{ label }}:</label>
                    <div class="box__input--i">
                        <input :id="'form_credentials_' + field" type="password" v-model="form.credentials[field]" placeholder="">
                        <tooltip :info="label" :ml="0"/>
                    </div>
                </div>
            </div>
            <button class="save" type="submit">Сохранить</button>
        </form>
    </div>
</template>

<script>
    import { mapGetters } from 'vuex';
    import Currencies from "../../currencies";
    import _ from "lodash";
    import WithdrawTypesRadio from "./WithdrawTypesRadio";

    export default {
		name: "PaymentSystemForm",
        props: ['payment_system'],
        data(){
            return {
                providers: { },
                form: {
                    provider: '',
                    name: '',
                    wallet: '',
                    code: '',
                    currency_id: 0,
                    refill_commission: 0.0,
                    min_refill_amount: 0.0,
                    max_refill_amount: 0.0,
                    withdraw_type: 'manual',
                    withdraw_commission: 0.0,
                    min_withdraw_amount: 0.0,
                    max_withdraw_amount: 0.0,
                    enabled: 1,
                    credentials: {

                    }
                },
            }
        },
        watch: {
            payment_system(payment_system){
                this.form = payment_system;
                if(!this.form.credentials){
                    this.form.credentials = {};
                }
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ]),
            currencies_options(){
                let currencies = Currencies.currencies;
                let options = {};
                if(Array.isArray(currencies) && currencies.length){
                    _.map(currencies, currency => {
                        options[currency.id] = currency.name;
                    });
                }
                return options;
            },
            providers_options(){
                let options = {};
                _.map(this.providers,
                    (provider, alias) => options[alias] = provider.name
                );
                return options;
            },
            provider_fields(){
                return this.providers.hasOwnProperty(this.form.provider) && this.providers[this.form.provider].fields ?
                    this.providers[this.form.provider].fields   :
                    {};
            },
            provider_withdraw_types(){
                return this.providers.hasOwnProperty(this.form.provider) && this.providers[this.form.provider].withdraw_types ?
                    this.providers[this.form.provider].withdraw_types   :
                    {};
            },
            formId(){
                return `form_${this._uid}`;
            }
        },
        methods: {
		    loadProviders(){
                this.axios
                    .get(`payment_systems/providers`)
                    .then(resp => resp.data)
                    .then(data => {
                        this.providers = Object.assign({}, data);
                        console.log(this.providers);
                    })
                ;
            },
            toggleEnabled(){
		        this.form.enabled = +!this.form.enabled;
            },
            submit(){
                this.$emit('submit', this.form);
            }
        },
        mounted(){
            this.loadProviders();
            if(this.payment_system){
                this.form = this.payment_system;
            }
        },
        components: {
		    WithdrawTypesRadio
        }
	}
</script>

<style scoped>

</style>
